﻿/*Copyright 2024 Wojciech Krzysztof Fiałkiewicz

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.*/

using System;
using System.Collections.Generic;
using System.IO;

namespace SonOfSun.Utils
{
    public class FilesReader
    {
        const string ResultsDir = "C:\\inetpub_logs\\results\\";

        private static List<string> ReturnFileNames()
        {
            DirectoryInfo di = new DirectoryInfo(ResultsDir);
            List<String> files = new List<string>();

            foreach (FileInfo fi in di.EnumerateFiles())
            {
                files.Add(fi.Name);
            }

            return files;
        }

        private static string GetValue(string line)
        {
            string[] arr = line.Split(':');

            return arr[1].Trim();
        }

        private static FileWithNumbers GetAllAndUnique(string name)
        {
            try
            {
                StreamReader reader = new StreamReader(ResultsDir + name);
                string line = reader.ReadLine();
                string previousLine = null;
                string previouspreviousline = null;
                FileWithNumbers fwn = new FileWithNumbers();

                do
                {
                    previouspreviousline = previousLine;
                    previousLine = line;
                } while ((line = reader.ReadLine()) != null);

                fwn.Name = name.Substring(0, name.Length - 5);
                fwn.AllVisits = GetValue(previouspreviousline);
                fwn.UniqueVisitors = GetValue(previousLine);

                return fwn;
            }
            catch (Exception)
            {
                return null;
            }
        }

        public static List<FileWithNumbers> GetFilesWithNumbers()
        {
            try
            {
                List<FileWithNumbers> files = new List<FileWithNumbers>();
                List<string> names = ReturnFileNames();

                foreach (string str in names)
                {
                    FileWithNumbers fwn = GetAllAndUnique(str);

                    if (fwn != null)
                    {
                        files.Add(GetAllAndUnique(str));
                    }
                }
                return files;
            }
            catch (Exception)
            {
                return null;
            }
        }
    }
}